"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiGatewayManagementApiService = exports.makeApiGatewayManagementApiService = void 0;
/**
 * @since 1.0.0
 */
const client_apigatewaymanagementapi_1 = require("@aws-sdk/client-apigatewaymanagementapi");
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Instance = __importStar(require("./ApiGatewayManagementApiClientInstance.js"));
const ApiGatewayManagementApiServiceConfig = __importStar(require("./ApiGatewayManagementApiServiceConfig.js"));
const Errors_js_1 = require("./Errors.js");
const commands = {
    DeleteConnectionCommand: client_apigatewaymanagementapi_1.DeleteConnectionCommand,
    GetConnectionCommand: client_apigatewaymanagementapi_1.GetConnectionCommand,
    PostToConnectionCommand: client_apigatewaymanagementapi_1.PostToConnectionCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
exports.makeApiGatewayManagementApiService = effect_1.Effect.gen(function* () {
    const client = yield* Instance.ApiGatewayManagementApiClientInstance;
    return yield* commons_1.Service.fromClientAndCommands(client, commands, {
        errorTags: Errors_js_1.AllServiceErrors,
        resolveClientConfig: ApiGatewayManagementApiServiceConfig.toApiGatewayManagementApiClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
class ApiGatewayManagementApiService extends effect_1.Effect.Tag("@effect-aws/client-api-gateway-management-api/ApiGatewayManagementApiService")() {
    static defaultLayer = effect_1.Layer.effect(this, exports.makeApiGatewayManagementApiService).pipe(effect_1.Layer.provide(Instance.layer));
    static layer = (config) => effect_1.Layer.effect(this, exports.makeApiGatewayManagementApiService).pipe(effect_1.Layer.provide(Instance.layer), effect_1.Layer.provide(ApiGatewayManagementApiServiceConfig.setApiGatewayManagementApiServiceConfig(config)));
    static baseLayer = (evaluate) => effect_1.Layer.effect(this, exports.makeApiGatewayManagementApiService).pipe(effect_1.Layer.provide(effect_1.Layer.effect(Instance.ApiGatewayManagementApiClientInstance, effect_1.Effect.map(ApiGatewayManagementApiServiceConfig.toApiGatewayManagementApiClientConfig, evaluate))));
}
exports.ApiGatewayManagementApiService = ApiGatewayManagementApiService;
//# sourceMappingURL=ApiGatewayManagementApiService.js.map