"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toApiGatewayManagementApiClientConfig = exports.setApiGatewayManagementApiServiceConfig = exports.withApiGatewayManagementApiServiceConfig = void 0;
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Function_1 = require("effect/Function");
const GlobalValue_1 = require("effect/GlobalValue");
/**
 * @since 1.0.0
 * @category api-gateway-management-api service config
 */
const currentApiGatewayManagementApiServiceConfig = (0, GlobalValue_1.globalValue)("@effect-aws/client-api-gateway-management-api/currentApiGatewayManagementApiServiceConfig", () => effect_1.FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category api-gateway-management-api service config
 */
exports.withApiGatewayManagementApiServiceConfig = (0, Function_1.dual)(2, (effect, config) => effect_1.Effect.locally(effect, currentApiGatewayManagementApiServiceConfig, config));
/**
 * @since 1.0.0
 * @category api-gateway-management-api service config
 */
const setApiGatewayManagementApiServiceConfig = (config) => effect_1.Layer.locallyScoped(currentApiGatewayManagementApiServiceConfig, config);
exports.setApiGatewayManagementApiServiceConfig = setApiGatewayManagementApiServiceConfig;
/**
 * @since 1.0.0
 * @category adapters
 */
exports.toApiGatewayManagementApiClientConfig = effect_1.Effect.gen(function* () {
    const { logger: serviceLogger, ...config } = yield* effect_1.FiberRef.get(currentApiGatewayManagementApiServiceConfig);
    const logger = serviceLogger === true
        ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.defaultServiceLogger)
        : (serviceLogger ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.make(serviceLogger)) : undefined);
    return { logger, ...config };
});
//# sourceMappingURL=ApiGatewayManagementApiServiceConfig.js.map