import { ServiceLogger } from "@effect-aws/commons";
import { Effect, FiberRef, Layer } from "effect";
import { dual } from "effect/Function";
import { globalValue } from "effect/GlobalValue";
/**
 * @since 1.0.0
 * @category api-gateway-management-api service config
 */
const currentApiGatewayManagementApiServiceConfig = globalValue("@effect-aws/client-api-gateway-management-api/currentApiGatewayManagementApiServiceConfig", () => FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category api-gateway-management-api service config
 */
export const withApiGatewayManagementApiServiceConfig = dual(2, (effect, config) => Effect.locally(effect, currentApiGatewayManagementApiServiceConfig, config));
/**
 * @since 1.0.0
 * @category api-gateway-management-api service config
 */
export const setApiGatewayManagementApiServiceConfig = (config) => Layer.locallyScoped(currentApiGatewayManagementApiServiceConfig, config);
/**
 * @since 1.0.0
 * @category adapters
 */
export const toApiGatewayManagementApiClientConfig = Effect.gen(function* () {
    const { logger: serviceLogger, ...config } = yield* FiberRef.get(currentApiGatewayManagementApiServiceConfig);
    const logger = serviceLogger === true
        ? yield* ServiceLogger.toClientLogger(ServiceLogger.defaultServiceLogger)
        : (serviceLogger ? yield* ServiceLogger.toClientLogger(ServiceLogger.make(serviceLogger)) : undefined);
    return { logger, ...config };
});
//# sourceMappingURL=ApiGatewayManagementApiServiceConfig.js.map